/*
 *    Copyright (c) 2012 by Bohumil Novacek <http://dzi.n.cz/8bit/>
 *
 *    Thies program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MZ-800 Unicard is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MZ-800 Unicard; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "pal.h"
#include <string.h>

extern const unsigned char FONT8x8[96*8];

extern unsigned char framebuffer1[464*(2+16)+8];
extern unsigned char borderbuffer1[300];
extern const unsigned char FONT8x8[96*8];

//const unsigned char BARVA[8]={0x00,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF};			//barvy mod MZ700
const unsigned char BARVA16[16]={0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,		//barvy mod MZ800
						0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF};

//obrazova pamet
static unsigned char ascii[0x1000];			//CG-RAM
static unsigned char GDC_text[0x1000];	//VRAM pro mod MZ700
//mezi ("double") buffer
static unsigned char framebuffer0[160*200];

//prepocitavaci tabulky pro urychleni vykresleni radku
static unsigned short tab[0x400];
static short bit701[256];
static short bit702[256];

unsigned char swapbits(unsigned char in) {
	unsigned char c=in;
	c=((c<<4)&0xF0)|((c>>4)&0x0F);
	c=((c<<2)&0xCC)|((c>>2)&0x33);
	c=((c<<1)&0xAA)|((c>>1)&0x55);
	return c;
}

//inicializace prepocitavacich tabulek
void pal_init(void) {
		int i;
		unsigned char a,b;
		unsigned char *buf=(unsigned char *)&tab[0];
		for(i=0;i<0x400;i++) {
			a=(i>>4)&7;if (a) a|=8;
			b=(i)&7;if (b) b|=8;
			*buf++ = ((i&0x08)?a:b) | (((i&0x80)?a:b)<<4);
			*buf++ = ((i&0x100)?a:b) | (((i&0x200)?a:b)<<4);
		}
		for(i=0;i<256;i++) {
			bit701[i]=((i&0x01)<<3)|((i&0x02)<<6)|((i&0x04)<<6)|((i&0x08)<<6);
			bit702[i]=((i&0x10)>>1)|((i&0x20)<<2)|((i&0x40)<<2)|((i&0x80)<<2);
		}
		for(i=0;i<2048;i++) GDC_text[i+2048]=0x71;
		for(i=0;i<2048;i++) GDC_text[i]=(i%96)+32;					//vyplnit obrazovku vsemi znaky
		memset(&ascii[0],0,32*8);
		for(i=0;i<96*8;i++) ascii[32*8+i]=swapbits(FONT8x8[i]);
		memset(&ascii[128*8],0,128*8);
		memset(borderbuffer1,1,sizeof(borderbuffer1));
}

//vykresleni jednoho TV radku do bufferu
void pal_line(int line) {
		if ((line<50)||(line>=250)) return;
		line-=50;
		{
			register unsigned short *buf=(unsigned short*)&framebuffer0[160*line];
			register unsigned char *text=&GDC_text[(line>>3)*40];
			register int i=10;
                        line &= 7;
			do {
				register unsigned char a;
				register unsigned short t;
				a=text[2048];
				t=(*text++)|((a&0x80)<<1);
				t=ascii[(t<<3)|line];
				*buf++ = tab[bit701[t]|(a&0x77)];
				*buf++ = tab[bit702[t]|(a&0x77)];

				a=text[2048];
				t=(*text++)|((a&0x80)<<1);
				t=ascii[(t<<3)|line];
				*buf++ = tab[bit701[t]|(a&0x77)];
				*buf++ = tab[bit702[t]|(a&0x77)];

				a=text[2048];
				t=(*text++)|((a&0x80)<<1);
				t=ascii[(t<<3)|line];
				*buf++ = tab[bit701[t]|(a&0x77)];
				*buf++ = tab[bit702[t]|(a&0x77)];

				a=text[2048];
				t=(*text++)|((a&0x80)<<1);
				t=ascii[(t<<3)|line];
				*buf++ = tab[bit701[t]|(a&0x77)];
				*buf++ = tab[bit702[t]|(a&0x77)];
			} while (--i);
		}
}

void pal_buf0_buf1(int line) {
		line=line-50;
		if ((line>=0)&&(line<200)) {
				unsigned long border=BARVA16[borderbuffer1[line+50]&0x0F]*0x01010101;register unsigned long *buf=(unsigned long*)&framebuffer1[464*(line&1)+20];
				register unsigned long *buf0=(unsigned long*)&framebuffer0[160*line];
//				register unsigned char *bufc;
				register int i=10;
				unsigned char paleta[16];
				memcpy(paleta,BARVA16,16);
				*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;
//				bufc=(unsigned char *)buf;
				do {
#if 0
					register unsigned long a;
						a=*buf0++;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];
						a=*buf0++;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];
						a=*buf0++;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];
						a=*buf0++;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];a>>=4;
						*bufc++=paleta[a&0x0F];
#else
  asm volatile (
    "ldr  r8,[%[data]],#4\n"
    "ubfx r7,r5,#0,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#4,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#8,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#12,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#16,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#20,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#24,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#28,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ldr  r8,[%[data]],#4\n"
    "ubfx r7,r5,#0,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#4,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#8,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#12,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#16,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#20,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#24,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#28,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ldr  r8,[%[data]],#4\n"
    "ubfx r7,r5,#0,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#4,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#8,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#12,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#16,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#20,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#24,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#28,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ldr  r8,[%[data]],#4\n"
    "ubfx r7,r5,#0,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#4,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#8,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#12,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#16,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#20,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#24,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    "ubfx r7,r8,#28,#4\n"
    "ldrb r6,[%[pal],r7]\n"
    "strb r6,[%[buf]],#1\n"
    : [buf] "+r" (buf), [data] "+r" (buf0) : [pal] "r" (paleta) : "r6","r7","r8");
#endif
				} while (--i);
//				buf=(unsigned long *)bufc;
				*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;*buf++=border;
		} else if (line<250) {
			memset(&framebuffer1[464*(line&1)+20],BARVA16[borderbuffer1[line+50]&0x0F],400);
		}
}
